---
name: Bug report
about: Create a report to help us track and fix problems
title: ''
labels: bug
---

**Description**
> A clear and concise description of what the bug is.

**Steps to reproduce**
> 1. Run the command X
> 2. Another step
> 3. See the error Y

**Expected result**
> A clear and concise description of what you expected to happen.

**Attachments**
> If applicable, provide logs, screenshots, screencast, etc to help explain your problem.

**Environment information**

* Operating System (if applicable, use the `uname -a` output): [e.g. Ubuntu 18.04]
* Tsuru installation method (Docker Compose; `tsuru install-create` command; manually; N/A): [e.g. Docker Compose]
* Tsuru API version (`tsuru/api` image tag or `tsurud version` command output): [e.g. 1.7.0]
* Tsuru client version (`tsuru/client` image tag or `tsuru version` command output): [e.g. 1.6.0]

**Cluster information**

* Node provider (umanaged/Cloud Stack/DigitalOcean/EC2): [e.g. unmanaged]
* Machine type (cloud/VM/bare metal): [e.g. VM]
* Machine specs (CPU, memory, disk, etc): [e.g. 2 vCPUs, 4GB RAM]
* Provisioner (`default`/`kubernetes`/`swarm`): [e.g. `default`]
* Docker version (if applicable, use the `docker version` output): [e.g. 18.09-ce]
* Kubernetes (if applicable, use the `kubectl version` output): [e.g. N/A]
